// Jrn Loviscach 2001-05-29, berarbeitet 2001-06-02

/*
Checkboxen, Radiobuttons, Textfelder,
Scrollflchen, Split, Baum, Tabelle, Listen,
Combo-Boxen, modale/nichtmodale Dialoge
*/

package checkboxetc;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.tree.*;

public class CheckBoxEtcDemo
{
  JFrame myFrame;

  public static void main(String[] args)
  {
    new CheckBoxEtcDemo();
  }

  CheckBoxEtcDemo()
  {
    myFrame = new JFrame("CheckBoxEtcDemo");
    myFrame.addWindowListener(new WindowAdapter(){public void windowClosing(WindowEvent e){System.exit(0);}});

    myFrame.setSize(600, 600);
    myFrame.setLocation(100, 100);

    JTabbedPane myTabbedPane = new JTabbedPane();

    JPanel checkAndRadioPanel = new JPanel();
    buildCheckAndRadioPanel(checkAndRadioPanel);

    JPanel textAndScrollPanel = new JPanel();
    buildTextAndScrollPanel(textAndScrollPanel);

    JPanel splitAndTreePanel = new JPanel();
    buildSplitAndTreePanel(splitAndTreePanel);

    JPanel tablePanel = new JPanel();
    buildTablePanel(tablePanel);

    JPanel listAndComboPanel = new JPanel();
    buildListAndComboPanel(listAndComboPanel);

    JPanel DialogPanel = new JPanel();
    buildDialogPanel(DialogPanel);

    myTabbedPane.addTab("Check und Radio", checkAndRadioPanel);
    myTabbedPane.addTab("Text und Scroll", textAndScrollPanel);
    myTabbedPane.addTab("Split und Tree", splitAndTreePanel);
    myTabbedPane.addTab("Tabelle", tablePanel);
    myTabbedPane.addTab("Liste und Combo Box", listAndComboPanel);
    myTabbedPane.addTab("Dialoge", DialogPanel);

    myFrame.getContentPane().add(myTabbedPane);
    myFrame.setVisible(true);
  }

  void buildCheckAndRadioPanel(JPanel checkAndRadioPanel)
  {
    final JCheckBox checkA = new JCheckBox("A");
    checkAndRadioPanel.add(checkA);

    final JCheckBox checkB = new JCheckBox("B: mit Action Listener");
    checkAndRadioPanel.add(checkB);
    checkB.addActionListener(new ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        {
          JOptionPane.showMessageDialog(myFrame, "Check Box mit ActionListener kann fr nichtmodale Dialoge sinnvoll sein.");
        }
      }
    );

    final JCheckBox checkC = new JCheckBox("C");
    checkAndRadioPanel.add(checkC);
    checkC.setSelected(true); // per Programm abhaken, z.B. fr Voreinstellungen

    final ButtonGroup myButtonGroupDEF = new ButtonGroup();
    // ntig, damit sich die Radio Buttons gegenseitig auslsen
    JRadioButton radioD = new JRadioButton("D");
    radioD.setActionCommand("D");
    myButtonGroupDEF.add(radioD); //logische Zuordnung
    checkAndRadioPanel.add(radioD); //grafische Zuordnung

    JRadioButton radioE = new JRadioButton("E: mit ActionListener");
    radioE.setActionCommand("E");
    myButtonGroupDEF.add(radioE); //logische Zuordnung
    checkAndRadioPanel.add(radioE); //grafische Zuordnung
    radioE.addActionListener(
      new ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        {
          JOptionPane.showMessageDialog(myFrame, "Radio Button mit ActionListener kann fr nichtmodale Dialoge sinnvoll sein.");
        }
      }
    );

    JRadioButton radioF = new JRadioButton("F");
    radioF.setActionCommand("F");
    myButtonGroupDEF.add(radioF); //logische Zuordnung
    checkAndRadioPanel.add(radioF); //grafische Zuordnung
    // Einer der Radio Buttons muss angeschaltet sein,
    // sonst logischer Fehler der Oberflchengestaltung:
    radioF.setSelected(true);

    // Besser sind meist Radion Buttons mit Umrahmung
    // in vertikaler Anordnung:
    JPanel myOptionPanel = new JPanel();
    myOptionPanel.setLayout(new GridLayout(0, 1));
    myOptionPanel.setBorder(BorderFactory.createTitledBorder("GHI"));
    checkAndRadioPanel.add(myOptionPanel);

    final ButtonGroup myButtonGroupGHI = new ButtonGroup();
    JRadioButton radioG = new JRadioButton("G");
    radioG.setActionCommand("G");
    myButtonGroupGHI.add(radioG); //logische Zuordnung
    myOptionPanel.add(radioG); //grafische Zuordnung
    radioG.setSelected(true);

    JRadioButton radioH = new JRadioButton("H");
    radioH.setActionCommand("H");
    myButtonGroupGHI.add(radioH); //logische Zuordnung
    myOptionPanel.add(radioH); //grafische Zuordnung

    JRadioButton radioI = new JRadioButton("I");
    radioI.setActionCommand("I");
    myButtonGroupGHI.add(radioI); //logische Zuordnung
    myOptionPanel.add(radioI); //grafische Zuordnung

    JButton z = new JButton("Zeige Auswahl an!");
    checkAndRadioPanel.add(z);

    final JTextField f = new JTextField("---");
    f.setEditable(false); // Benutzer soll nichts eintippen drfen
    f.setPreferredSize(new Dimension(300, 20));
    checkAndRadioPanel.add(f);

    z.addActionListener(
      new ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        {
          String s;
          s  = checkA.isSelected() ? "A" : ""; // zu knapp formuliert?
          s += checkB.isSelected() ? "B" : "";
          s += checkC.isSelected() ? "C" : "";
          s += myButtonGroupDEF.getSelection().getActionCommand();
          s += myButtonGroupGHI.getSelection().getActionCommand();
          f.setText(s);
        }
      }
    );

  }

  void buildTextAndScrollPanel(JPanel textAndScrollPanel)
  {
    textAndScrollPanel.setLayout(new BorderLayout());
    JTextPane myTextPane = new JTextPane();
    JScrollPane myScrollPane = new JScrollPane(myTextPane);
    textAndScrollPanel.add(myScrollPane, BorderLayout.CENTER);
    // Scrollen geht natrlich auch mit anderen Komponenten,
    // nicht nur mit JTextPane!
  }

  void buildSplitAndTreePanel(JPanel splitAndTreePanel)
  {
    JTextPane myTextPane = new JTextPane();
    JScrollPane myScrollPane = new JScrollPane(myTextPane);

    MutableTreeNode root = new DefaultMutableTreeNode("A");
    MutableTreeNode cde = new DefaultMutableTreeNode("CDE");
    root.insert(cde, 0);
    root.insert(new DefaultMutableTreeNode("B"), 1);
    cde.insert(new DefaultMutableTreeNode("C"), 0);
    cde.insert(new DefaultMutableTreeNode("D"), 1);
    cde.insert(new DefaultMutableTreeNode("E"), 2);

    TreeModel model = new DefaultTreeModel(root);

    JTree myTree = new JTree(model);

    JSplitPane mySplitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, myTree, myScrollPane);
    splitAndTreePanel.setLayout(new BorderLayout());
    splitAndTreePanel.add(mySplitPane, BorderLayout.CENTER);
  }

  void buildTablePanel(JPanel tablePanel)
  {
    String[] heading = new String[] {"Ort", "PLZ", "Zieh mich!"};

    Object[][] data =
      new Object[][]
      {
        {"Ahaus", "12345", "2345"},
        {"Beheim", "34567", "13634"},
        {"Cedorf", "25335", "5234"},
        {"Editier mich!", "54643", "1234"}
      };

    JTable myTable = new JTable(data, heading);
    JScrollPane myScrollPane = new JScrollPane(myTable);
    // Einbettung in JScrollPane, damit Spaltentitel sichtbar.
    tablePanel.add(myScrollPane);
  }

  void buildListAndComboPanel(JPanel listAndComboPanel)
  {
    String items[] = {"A", "B", "C", "D"};

    final JList myList = new JList(items);
    listAndComboPanel.add(myList);

    final JComboBox myCombo = new JComboBox(items);
    myCombo.setEditable(true); //auch etwas Eigenes eingeben
    listAndComboPanel.add(myCombo);

    JButton z = new JButton("Zeige Auswahl an!");
    listAndComboPanel.add(z);

    final JTextField f = new JTextField("---");
    f.setEditable(false); // Benutzer soll nichts eintippen drfen
    f.setPreferredSize(new Dimension(200, 20));
    listAndComboPanel.add(f);

    z.addActionListener(
      new ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        {
          String s = "Liste: ";
          Object sel[] = myList.getSelectedValues();
          for(int i=0; i<sel.length; i++)
          {
            s += sel[i];
          }
          s += ", Combo: " + myCombo.getSelectedItem();
          f.setText(s);
        }
      }
    );

  }

  void buildDialogPanel(JPanel dialogPanel)
  {
    JButton buttonModal = new JButton("Modaler Dialog mit JOptionPane");
    dialogPanel.add(buttonModal);

    JButton buttonNonModal = new JButton("Nichtmodaler Dialog mit JFrame an/aus");
    dialogPanel.add(buttonNonModal);

    JButton buttonModalJDialog = new JButton("Modaler Dialog mit JDialog");
    dialogPanel.add(buttonModalJDialog);

    JButton buttonNonModalJDialog = new JButton("Nichtmodaler Dialog mit JDialog");
    dialogPanel.add(buttonNonModalJDialog);

    final JTextField t = new JTextField();
    t.setPreferredSize(new Dimension(300, 20));
    dialogPanel.add(t);

    buttonModal.addActionListener(
      new ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        {
          JTextField myText = new JTextField();
          int result = JOptionPane.showOptionDialog(myFrame,
                          new Object[] {myText}, // knnten auch mehr Elemente sein
                          "Modaler Dialog mit JOptionPane",
                          JOptionPane.OK_CANCEL_OPTION,
                          JOptionPane.QUESTION_MESSAGE, null, null, null);
          if(result == JOptionPane.OK_OPTION)
          {
            t.setText(myText.getText());
          }
        }
      }
    );

    // das Folgende lieber nicht mit anonymen inneren Klassen,
    // weil zu unbersichtlich

    // Beachte: Man knnte die Dialogfenster vernichten, wenn sie
    // nicht mehr auf dem Bildschirm sind. Wir erzeugen sie
    // dagegen einmal zu Beginn und vernichten sie nicht selbst.
    // Nach Schlieen und Wiederffnen erscheint ein Dialogfenster
    // deshalb am alten Platz und in alter Gre.

    buttonNonModal.addActionListener(new NonModal(t));
    buttonModalJDialog.addActionListener(new ModalJDialog(myFrame, t));
    buttonNonModalJDialog.addActionListener(new NonModalJDialog(myFrame, t));
  }
}

class NonModal
implements ActionListener
{
  JFrame myDialogFrame;
  JTextField myText;
  JTextField textOfMyParent;

  NonModal(JTextField t)
  {
    textOfMyParent = t;
    myDialogFrame = new JFrame("Nichtmodaler Dialog mit JFrame");
    myDialogFrame.setSize(250, 150);
    myDialogFrame.setLocation(700, 400);

    myDialogFrame.getContentPane().setLayout(new GridLayout(0,1));

    myText = new JTextField();
    myDialogFrame.getContentPane().add(myText);

    JButton myButton = new JButton("bernehmen");
    myDialogFrame.getContentPane().add(myButton);
    myButton.addActionListener(
      new ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        {
          textOfMyParent.setText(myText.getText());
        }
      }
    );

  }

  public void actionPerformed(ActionEvent e)
  {
    myDialogFrame.setVisible(!myDialogFrame.isVisible());
  }
}

class ModalJDialog
implements ActionListener
{
  JDialog myDialog;
  JTextField myText1, myText2;
  JFrame ownerFrame;
  JTextField textOfMyParent;
  boolean isShowingForTheFirstTime = true;

  ModalJDialog(JFrame o, JTextField t)
  {
    ownerFrame = o;
    textOfMyParent = t;
    myDialog = new JDialog(ownerFrame, "Modaler Dialog mit JDialog", true);
    // true heit: modal statt nichtmodal, ownerFrame wird blockiert

    myDialog.getContentPane().setLayout(new GridLayout(0, 1));

    myDialog.getContentPane().add(new JLabel("Als Demo zwei Felder:"));
    myText1 = new JTextField();
    myDialog.getContentPane().add(myText1);
    myText2 = new JTextField();
    myDialog.getContentPane().add(myText2);

    JButton okButton = new JButton("OK");
    myDialog.getContentPane().add(okButton);
    myDialog.getRootPane().setDefaultButton(okButton); // Return-Taste bettigt OK
    okButton.addActionListener(
      new ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        {
          textOfMyParent.setText("1:" + myText1.getText() + " 2:" + myText2.getText());
          myDialog.hide();
        }
      }
    );

    myDialog.pack(); // automatisch so gro, dass optimal (auer Fenstertitel ...)
    myDialog.setResizable(false); // Benutzer kann Gre nicht ndern

    myDialog.setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
    // einfache Lsung zu verhindern, dass der Dialog
    // per Schliefeld (X-Knopf) verlassen wird
  }

  public void actionPerformed(ActionEvent e)
  {
    // Hier knnte man noch die Textfelder voreinstellen,
    // z.B. mit den aktuellen Daten aus dem Hauptfenster.

    if(isShowingForTheFirstTime)
    {
          myDialog.setLocationRelativeTo(ownerFrame); // ber dem ownerFrame darstellen
          // Das kann man nicht im Konstruktor von ModalJDialog aufrufen,
          // weil zu dem Zeitpunkt der ownerFrame noch nicht sichtbar ist.
          isShowingForTheFirstTime = false;
    }
    myDialog.show();
  }
}

class NonModalJDialog
implements ActionListener
{
  JDialog myDialog;
  JTextField myText1, myText2;
  JFrame ownerFrame;
  JTextField textOfMyParent;

  NonModalJDialog(JFrame o, JTextField t)
  {
    ownerFrame = o;
    textOfMyParent = t;
    myDialog = new JDialog(ownerFrame, "Nichtmodaler Dialog mit JDialog", false);
    // false heit: nichtmodal statt modal

    myDialog.getContentPane().setLayout(new GridLayout(0, 1));

    myDialog.getContentPane().add(new JLabel("Als Demo zwei Felder:"));
    myText1 = new JTextField();
    myDialog.getContentPane().add(myText1);
    myText2 = new JTextField();
    myDialog.getContentPane().add(myText2);

    JButton applyButton = new JButton("bernehmen");
    myDialog.getContentPane().add(applyButton);
    applyButton.addActionListener(
      new ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        {
          textOfMyParent.setText("1:" + myText1.getText() + " 2:" + myText2.getText());
        }
      }
    );

    JButton closeButton = new JButton("Schlieen");
    myDialog.getContentPane().add(closeButton);
    closeButton.addActionListener(
      new ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        {
          myDialog.hide();
        }
      }
    );

    myDialog.pack(); // automatisch so gro, wie optimal
    myDialog.setLocation(700, 400);
    // _nicht_modalen Dialog besser an den Rand setzen
  }

  public void actionPerformed(ActionEvent e)
  {
    // Hier knnte man noch die Textfelder voreinstellen,
    // z.B. mit den aktuellen Daten aus dem Hauptfenster.
    myDialog.show();
  }
}